'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.initAssetRegisters = initAssetRegisters;

var _config = require('../config');

var _config2 = _interopRequireDefault(_config);

var _constants = require('vue-template-compiler/lib/shared/constants');

var _index = require('../util/index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function initAssetRegisters(Vue) {
  /**
   * Create asset registration methods.
   */
  _constants.ASSET_TYPES.forEach(function (type) {
    Vue[type] = function (id, definition) {
      if (!definition) {
        return this.options[type + 's'][id];
      } else {
        /* istanbul ignore if */
        if (process.env.NODE_ENV !== 'production') {
          if (type === 'component' && _config2.default.isReservedTag(id)) {
            (0, _index.warn)('Do not use built-in or reserved HTML elements as component ' + 'id: ' + id);
          }
        }
        if (type === 'component' && (0, _index.isPlainObject)(definition)) {
          definition.name = definition.name || id;
          definition = this.options._base.extend(definition);
        }
        if (type === 'directive' && typeof definition === 'function') {
          definition = { bind: definition, update: definition };
        }
        this.options[type + 's'][id] = definition;
        return definition;
      }
    };
  });
}