'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _init = require('./init');

var _state = require('./state');

var _render = require('./render');

var _events = require('./events');

var _lifecycle = require('./lifecycle');

var _index = require('../util/index');

function Vue(options) {
  if (process.env.NODE_ENV !== 'production' && !(this instanceof Vue)) {
    (0, _index.warn)('Vue is a constructor and should be called with the `new` keyword');
  }
  this._init(options);
}

(0, _init.initMixin)(Vue);
(0, _state.stateMixin)(Vue);
(0, _events.eventsMixin)(Vue);
(0, _lifecycle.lifecycleMixin)(Vue);
(0, _render.renderMixin)(Vue);

exports.default = Vue;