'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.bindObjectListeners = bindObjectListeners;

var _index = require('vue-template-compiler/lib/core/util/index');

function bindObjectListeners(data, value) {
  if (value) {
    if (!(0, _index.isPlainObject)(value)) {
      process.env.NODE_ENV !== 'production' && (0, _index.warn)('v-on without argument expects an Object value', this);
    } else {
      var on = data.on = data.on ? (0, _index.extend)({}, data.on) : {};
      for (var key in value) {
        var existing = on[key];
        var ours = value[key];
        on[key] = existing ? [].concat(ours, existing) : ours;
      }
    }
  }
  return data;
}