'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.renderList = renderList;

var _index = require('vue-template-compiler/lib/core/util/index');

/**
 * Runtime helper for rendering v-for lists.
 */
function renderList(val, render) {
  var ret = void 0,
      i = void 0,
      l = void 0,
      keys = void 0,
      key = void 0;
  if (Array.isArray(val) || typeof val === 'string') {
    ret = new Array(val.length);
    for (i = 0, l = val.length; i < l; i++) {
      ret[i] = render(val[i], i);
    }
  } else if (typeof val === 'number') {
    ret = new Array(val);
    for (i = 0; i < val; i++) {
      ret[i] = render(i + 1, i);
    }
  } else if ((0, _index.isObject)(val)) {
    keys = Object.keys(val);
    ret = new Array(keys.length);
    for (i = 0, l = keys.length; i < l; i++) {
      key = keys[i];
      ret[i] = render(val[key], key, i);
    }
  }
  if ((0, _index.isDef)(ret)) {
    ret._isVList = true;
  }
  return ret;
}