'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.renderSlot = renderSlot;

var _index = require('vue-template-compiler/lib/core/util/index');

/**
 * Runtime helper for rendering <slot>
 */
function renderSlot(name, fallback, props, bindObject) {
  var scopedSlotFn = this.$scopedSlots[name];
  if (scopedSlotFn) {
    // scoped slot
    props = props || {};
    if (bindObject) {
      props = (0, _index.extend)((0, _index.extend)({}, bindObject), props);
    }
    return scopedSlotFn(props) || fallback;
  } else {
    var slotNodes = this.$slots[name];
    // warn duplicate slot usage
    if (slotNodes && process.env.NODE_ENV !== 'production') {
      slotNodes._rendered && (0, _index.warn)('Duplicate presence of slot "' + name + '" found in the same render tree ' + '- this will likely cause render errors.', this);
      slotNodes._rendered = true;
    }
    return slotNodes || fallback;
  }
}