'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.handleError = handleError;

var _config = require('../config');

var _config2 = _interopRequireDefault(_config);

var _debug = require('./debug');

var _env = require('./env');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function handleError(err, vm, info) {
  if (_config2.default.errorHandler) {
    _config2.default.errorHandler.call(null, err, vm, info);
  } else {
    if (process.env.NODE_ENV !== 'production') {
      (0, _debug.warn)('Error in ' + info + ': "' + err.toString() + '"', vm);
    }
    /* istanbul ignore else */
    if (_env.inBrowser && typeof console !== 'undefined') {
      console.error(err);
    } else {
      throw err;
    }
  }
}