'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createBundleRenderer = undefined;
exports.createRenderer = createRenderer;

var _index = require('./server/modules/index');

var _index2 = _interopRequireDefault(_index);

var _index3 = require('./server/directives/index');

var _index4 = _interopRequireDefault(_index3);

var _util = require('./compiler/util');

var _createRenderer2 = require('vue-template-compiler/lib/server/create-renderer');

var _createBundleRenderer = require('vue-template-compiler/lib/server/bundle-renderer/create-bundle-renderer');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

process.env.VUE_ENV = 'server';

function createRenderer() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  return (0, _createRenderer2.createRenderer)(Object.assign({}, options, {
    isUnaryTag: _util.isUnaryTag,
    canBeLeftOpenTag: _util.canBeLeftOpenTag,
    modules: _index2.default,
    // user can provide server-side implementations for custom directives
    // when creating the renderer.
    directives: Object.assign(_index4.default, options.directives)
  }));
}

var createBundleRenderer = exports.createBundleRenderer = (0, _createBundleRenderer.createBundleRendererCreator)(createRenderer);