'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = renderAttrs;
exports.renderAttr = renderAttr;

var _util = require('../util');

var _util2 = require('vue-template-compiler/lib/shared/util');

var _attrs = require('vue-template-compiler/lib/platforms/web/util/attrs');

function renderAttrs(node) {
  var attrs = node.data.attrs;
  var res = '';

  var opts = node.parent && node.parent.componentOptions;
  if ((0, _util2.isUndef)(opts) || opts.Ctor.options.inheritAttrs !== false) {
    var parent = node.parent;
    while ((0, _util2.isDef)(parent)) {
      if ((0, _util2.isDef)(parent.data) && (0, _util2.isDef)(parent.data.attrs)) {
        attrs = Object.assign({}, attrs, parent.data.attrs);
      }
      parent = parent.parent;
    }
  }

  if ((0, _util2.isUndef)(attrs)) {
    return res;
  }

  for (var key in attrs) {
    if (key === 'style') {
      // leave it to the style module
      continue;
    }
    res += renderAttr(key, attrs[key]);
  }
  return res;
}

function renderAttr(key, value) {
  if ((0, _attrs.isBooleanAttr)(key)) {
    if (!(0, _attrs.isFalsyAttrValue)(value)) {
      return ' ' + key + '="' + key + '"';
    }
  } else if ((0, _attrs.isEnumeratedAttr)(key)) {
    return ' ' + key + '="' + ((0, _attrs.isFalsyAttrValue)(value) || value === 'false' ? 'false' : 'true') + '"';
  } else if (!(0, _attrs.isFalsyAttrValue)(value)) {
    return ' ' + key + '="' + (typeof value === 'string' ? (0, _util.cachedEscape)(value) : value) + '"';
  }
  return '';
}