'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.genStyle = genStyle;
exports.default = renderStyle;

var _util = require('../util');

var _util2 = require('vue-template-compiler/lib/shared/util');

var _style = require('vue-template-compiler/lib/platforms/web/util/style');

function genStyle(style) {
  var styleText = '';
  for (var key in style) {
    var value = style[key];
    var hyphenatedKey = (0, _util2.hyphenate)(key);
    if (Array.isArray(value)) {
      for (var i = 0, len = value.length; i < len; i++) {
        styleText += hyphenatedKey + ':' + value[i] + ';';
      }
    } else {
      styleText += hyphenatedKey + ':' + value + ';';
    }
  }
  return styleText;
}

function renderStyle(vnode) {
  var styleText = genStyle((0, _style.getStyle)(vnode, false));
  if (styleText !== '') {
    return ' style=' + JSON.stringify((0, _util.cachedEscape)(styleText));
  }
}