'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isFalsyAttrValue = exports.getXlinkProp = exports.isXlink = exports.xlinkNS = exports.isBooleanAttr = exports.isEnumeratedAttr = exports.mustUseProp = exports.isReservedAttr = undefined;

var _util = require('vue-template-compiler/lib/shared/util');

// these are reserved for web because they are directly compiled away
// during template compilation
var isReservedAttr = exports.isReservedAttr = (0, _util.makeMap)('style,class');

// attributes that should be using props for binding


var acceptValue = (0, _util.makeMap)('input,textarea,option,select');
var mustUseProp = exports.mustUseProp = function mustUseProp(tag, type, attr) {
  return attr === 'value' && acceptValue(tag) && type !== 'button' || attr === 'selected' && tag === 'option' || attr === 'checked' && tag === 'input' || attr === 'muted' && tag === 'video';
};

var isEnumeratedAttr = exports.isEnumeratedAttr = (0, _util.makeMap)('contenteditable,draggable,spellcheck');

var isBooleanAttr = exports.isBooleanAttr = (0, _util.makeMap)('allowfullscreen,async,autofocus,autoplay,checked,compact,controls,declare,' + 'default,defaultchecked,defaultmuted,defaultselected,defer,disabled,' + 'enabled,formnovalidate,hidden,indeterminate,inert,ismap,itemscope,loop,multiple,' + 'muted,nohref,noresize,noshade,novalidate,nowrap,open,pauseonexit,readonly,' + 'required,reversed,scoped,seamless,selected,sortable,translate,' + 'truespeed,typemustmatch,visible');

var xlinkNS = exports.xlinkNS = 'http://www.w3.org/1999/xlink';

var isXlink = exports.isXlink = function isXlink(name) {
  return name.charAt(5) === ':' && name.slice(0, 5) === 'xlink';
};

var getXlinkProp = exports.getXlinkProp = function getXlinkProp(name) {
  return isXlink(name) ? name.slice(6, name.length) : '';
};

var isFalsyAttrValue = exports.isFalsyAttrValue = function isFalsyAttrValue(val) {
  return val == null || val === false;
};