'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = model;

var _helpers = require('vue-template-compiler/lib/compiler/helpers');

var _model = require('vue-template-compiler/lib/compiler/directives/model');

function model(el, dir, _warn) {
  if (el.tag === 'input' || el.tag === 'textarea') {
    genDefaultModel(el, dir.value, dir.modifiers);
  } else {
    (0, _model.genComponentModel)(el, dir.value, dir.modifiers);
  }
}

function genDefaultModel(el, value, modifiers) {
  var _ref = modifiers || {},
      lazy = _ref.lazy,
      trim = _ref.trim,
      number = _ref.number;

  var event = lazy ? 'change' : 'input';

  var valueExpression = '$event.target.attr.value' + (trim ? '.trim()' : '');
  if (number) {
    valueExpression = '_n(' + valueExpression + ')';
  }

  var code = (0, _model.genAssignmentCode)(value, valueExpression);
  (0, _helpers.addAttr)(el, 'value', '(' + value + ')');
  (0, _helpers.addHandler)(el, event, code, null, true);
}