'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.compileToFunctions = exports.compile = exports.baseOptions = undefined;

var _util = require('vue-template-compiler/lib/shared/util');

var _index = require('vue-template-compiler/lib/compiler/index');

var _index2 = require('./modules/index');

var _index3 = _interopRequireDefault(_index2);

var _index4 = require('./directives/index');

var _index5 = _interopRequireDefault(_index4);

var _index6 = require('../util/index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var baseOptions = exports.baseOptions = {
  modules: _index3.default,
  directives: _index5.default,
  isUnaryTag: _index6.isUnaryTag,
  mustUseProp: _index6.mustUseProp,
  canBeLeftOpenTag: _index6.canBeLeftOpenTag,
  isReservedTag: _index6.isReservedTag,
  getTagNamespace: _index6.getTagNamespace,
  preserveWhitespace: false,
  staticKeys: (0, _util.genStaticKeys)(_index3.default)
};

var _createCompiler = (0, _index.createCompiler)(baseOptions),
    compile = _createCompiler.compile,
    compileToFunctions = _createCompiler.compileToFunctions;

exports.compile = compile;
exports.compileToFunctions = compileToFunctions;