'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isUnaryTag = exports.canBeLeftOpenTag = exports.isReservedTag = undefined;
exports.mustUseProp = mustUseProp;
exports.getTagNamespace = getTagNamespace;
exports.isUnknownElement = isUnknownElement;
exports.query = query;

var _util = require('vue-template-compiler/lib/shared/util');

var isReservedTag = exports.isReservedTag = (0, _util.makeMap)('template,script,style,element,content,slot,link,meta,svg,view,' + 'a,div,img,image,text,span,richtext,input,switch,textarea,spinner,select,' + 'slider,slider-neighbor,indicator,trisition,trisition-group,canvas,' + 'list,cell,header,loading,loading-indicator,refresh,scrollable,scroller,' + 'video,web,embed,tabbar,tabheader,datepicker,timepicker,marquee,countdown', true);

// Elements that you can, intentionally, leave open (and which close themselves)
// more flexable than web
/* globals renderer */

var canBeLeftOpenTag = exports.canBeLeftOpenTag = (0, _util.makeMap)('web,spinner,switch,video,textarea,canvas,' + 'indicator,marquee,countdown', true);

var isUnaryTag = exports.isUnaryTag = (0, _util.makeMap)('embed,img,image,input,link,meta', true);

function mustUseProp() {/* console.log('mustUseProp') */}
function getTagNamespace() {/* console.log('getTagNamespace') */}
function isUnknownElement() {/* console.log('isUnknownElement') */}

function query(el, document) {
  // renderer is injected by weex factory wrapper
  var placeholder = new renderer.Comment('root');
  placeholder.hasAttribute = placeholder.removeAttribute = function () {}; // hack for patch
  document.documentElement.appendChild(placeholder);
  return placeholder;
}