'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _util = require('../util');

Object.defineProperty(exports, 'isJS', {
  enumerable: true,
  get: function get() {
    return _util.isJS;
  }
});
Object.defineProperty(exports, 'isCSS', {
  enumerable: true,
  get: function get() {
    return _util.isCSS;
  }
});

var _require = require('chalk'),
    red = _require.red,
    yellow = _require.yellow;

var prefix = '[vue-server-renderer-webpack-plugin]';
var warn = exports.warn = function (msg) {
  return console.error(red(prefix + ' ' + msg + '\n'));
};
var tip = exports.tip = function (msg) {
  return console.log(yellow(prefix + ' ' + msg + '\n'));
};

var validate = exports.validate = function validate(compiler) {
  if (compiler.options.target !== 'node') {
    warn('webpack config `target` should be "node".');
  }

  if (compiler.options.output && compiler.options.output.libraryTarget !== 'commonjs2') {
    warn('webpack config `output.libraryTarget` should be "commonjs2".');
  }

  if (!compiler.options.externals) {
    tip('It is recommended to externalize dependencies in the server build for ' + 'better build performance.');
  }
};